"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactVisibilitySensor = _interopRequireDefault(require("react-visibility-sensor"));

var _StackBlur = _interopRequireDefault(require("./StackBlur"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var isInDom = !!(typeof window !== 'undefined' && window.document && window.document.createElement);

var LazyImage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LazyImage, _React$Component);

  function LazyImage(props) {
    var _this;

    _classCallCheck(this, LazyImage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LazyImage).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handlePlaceholderLoaded", function () {
      var _this$props = _this.props,
          placeholderWidth = _this$props.placeholderWidth,
          placeholderHeight = _this$props.placeholderHeight;
      var canvas = _this.canvasEl;
      (0, _StackBlur.default)(_this.placeholderEl, canvas, placeholderWidth, placeholderHeight, _this.props.radius);

      _this.setState({
        isCanvasLoaded: true
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "calculateDimension", function (_ref) {
      var imgWidth = _ref.imgWidth,
          imgHeight = _ref.imgHeight;

      var rect = _this.wrap.getBoundingClientRect();

      var width = rect.width;
      var height = parseInt(width / imgWidth * imgHeight, 10);
      return {
        width: width,
        height: height
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleVisibleChange", function (isVisible) {
      if (!isInDom) return;
      var isLoaded = _this.state.isLoaded;

      if (isVisible) {
        if (!isLoaded) {
          _this.loadOriginImage();
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "loadOriginImage", function () {
      _this.setState({
        status: 'is-loading'
      });

      var source = _this.props.source;
      var img = new Image();

      img.onload = function () {
        if (_this.props.height === 'auto') {
          var dimension = _this.calculateDimension({
            imgWidth: img.width,
            imgHeight: img.height
          });

          _this.setState(dimension);
        }

        _this.setState({
          status: 'is-loaded',
          isLoaded: true
        });
      };

      img.src = source;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getWrapRef", function (ref) {
      _this.wrap = ref;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getCanvas", function (ref) {
      _this.canvasEl = ref;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getPlaceholderRef", function (ref) {
      _this.placeholderEl = ref;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getCanvasDimension", function () {
      var _this$state = _this.state,
          width = _this$state.width,
          height = _this$state.height;
      return {
        width: width + 'px',
        height: height + 'px'
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderOriginal", function () {
      var _this$props2 = _this.props,
          source = _this$props2.source,
          alt = _this$props2.alt,
          children = _this$props2.children;
      var isLoaded = _this.state.isLoaded;
      return isLoaded ? children({
        source: source,
        alt: alt
      }) : null;
    });

    _this.state = {
      status: '',
      isLoaded: false,
      width: props.width,
      height: props.height,
      isCanvasLoaded: false
    };
    return _this;
  }

  _createClass(LazyImage, [{
    key: "render",
    value: function render() {
      var _classNames;

      // fix ssr
      var _this$props3 = this.props,
          classPrefix = _this$props3.classPrefix,
          placeholder = _this$props3.placeholder,
          alt = _this$props3.alt,
          sensorProps = _this$props3.sensorProps;
      var _this$state2 = this.state,
          isLoaded = _this$state2.isLoaded,
          width = _this$state2.width,
          height = _this$state2.height,
          isCanvasLoaded = _this$state2.isCanvasLoaded;
      var cls = (0, _classnames.default)('nc-lazy-image', (_classNames = {
        'is-loaded': isLoaded
      }, _defineProperty(_classNames, classPrefix, !!classPrefix), _defineProperty(_classNames, 'is-canvas-loaded', isCanvasLoaded), _classNames));

      var onChange = sensorProps.onChange,
          rest = _objectWithoutProperties(sensorProps, ["onChange"]); //eslint-disable-line


      return _react.default.createElement(_reactVisibilitySensor.default, _extends({
        onChange: this.handleVisibleChange
      }, rest), _react.default.createElement("div", {
        className: cls,
        style: {
          width: width,
          height: height
        },
        ref: this.getWrapRef
      }, _react.default.createElement("img", {
        className: "nc-lazy-placeholder",
        ref: this.getPlaceholderRef,
        crossOrigin: "anonymous",
        src: placeholder,
        alt: alt,
        onLoad: this.handlePlaceholderLoaded
      }), _react.default.createElement("canvas", {
        className: "nc-lazy-canvas",
        ref: this.getCanvas
      }), _react.default.createElement("div", {
        className: "nc-lazy-source"
      }, isInDom ? this.renderOriginal() : null)));
    }
  }]);

  return LazyImage;
}(_react.default.Component);

LazyImage.propTypes = {
  source: _propTypes.default.string.isRequired,
  placeholder: _propTypes.default.string.isRequired,
  alt: _propTypes.default.string,
  children: _propTypes.default.func,
  classPrefix: _propTypes.default.string,
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  height: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  radius: _propTypes.default.number,
  placeholderWidth: _propTypes.default.number,
  placeholderHeight: _propTypes.default.number,
  sensorProps: _propTypes.default.object
};
LazyImage.defaultProps = {
  alt: 'image alt',
  radius: 10,
  width: '100%',
  height: 'auto',
  placeholderWidth: 20,
  placeholderHeight: 20,
  sensorProps: {
    partialVisibility: true,
    offset: {
      top: 0
    }
  }
};
var _default = LazyImage;
exports.default = _default;